import java.util.*;
import java.io.*;
import java.net.*;

public class LivreODSkelton extends MyRemoteObjectInvocation
{
    private LivreOD serviceOD;

    public LivreODSkelton(LivreOD serviceOD)
    {
        super(serviceOD.getPort(),serviceOD);
        this.serviceOD = serviceOD;
    }

    public void invoke(String methode,
                       ObjectOutputStream oos,
                       ObjectInputStream ois) throws MyRemoteException
    {
        try{
            if (methode.equals("getNom"))
                {
                    System.out.println(">>invoke: getNom");
                    String nom = serviceOD.getNom();
                    oos.writeObject(nom);
                }
            
            if (methode.equals("getType"))
                {
                    System.out.println(">>invoke: getType");
                    String type = serviceOD.getType();
                    oos.writeObject(type);
                }
        }catch(Exception ex)
            {
                System.out.println("Erreur dans LivreSkelton : invoke");
                System.out.println(ex);
                ex.printStackTrace();
                throw new MyRemoteException(ex);
            }
    }
}